from BeautifulSoup import BeautifulSoup
import urllib2
import sys
import re
import shutil
import os
import urlparse
import time
from pprint import pprint


# Debug Purposes Only
#h = urllib2.HTTPHandler(debuglevel=1)
h = urllib2.HTTPHandler(debuglevel=0)
opener = urllib2.build_opener(h)

# Penny Arcade hates scrapers, let's pretend to be Firefox 
agent = "Mozilla/4.0"
headers = {'User-Agent': agent}





def download_comic(url):
	print url
	try:
		global soup
		req = urllib2.Request(url, data=None, headers=headers)
		html = opener.open(req).read()
		soup = BeautifulSoup(html)
		tables = soup.findAll('img')
		comic_image = tables[0]
		image_url = comic_image['src']
		ext = os.path.splitext(image_url)
		#I originally had the title as part of the name, but some comics had characters that were not file system friendly.
		#image_name=url[34:38]+url[39:41]+url[42:44] +' - '+ comic_image['alt']+ext[1]
		image_name=url[34:38]+url[39:41]+url[42:44]+ext[1]
		
		# Download the image and save it to disk
		if not os.path.exists('Penny Arcade'):
			os.mkdir('Penny Arcade')

		f = open('Penny Arcade'+os.sep+os.path.basename(image_name),'wb')
		req = urllib2.Request(image_url, data=None, headers=headers)
		f.write(opener.open(req).read())
		f.close()

	except:
			print('Excemption Found - Retrying in 10 Seconds')
			time.sleep(10)
			download_comic(url)
	
	
def scrape_pa_1(url):
	global soup
	download_comic(url)
	tables = soup.findAll('div')
	buttons_table = tables[16]
	button_links = buttons_table.findAll('a')
	next_url = button_links[3]['href']
	if next_url == 'http://www.penny-arcade.com/comic/': sys.exit("Done!")
	else: 
		#2 Second delay to minimize "503 - Service Unavailable" error
		time.sleep(2)
		scrape_pa_1(next_url)

		
#First Comic - Uncomment to get entire archive	
#scrape_pa_1('http://www.penny-arcade.com/comic/1998/11/18')

global soup
scrape_pa_1('http://www.penny-arcade.com/comic/1998/11/18')